library ArcNeuralNetwork.StopCondition;

import "../neuron.dart";

abstract class StopCondition {
  bool isFinished(condition);
}

class MaxIteration implements StopCondition {
  int maxIterations;

  MaxIteration(this.maxIterations) {}

  bool isFinished(iteration) {
    if (iteration < this.maxIterations) {
      return false;
    }
    return true;
  }
}

class MinError implements StopCondition {
  double minError;

  MinError(this.minError) {}

  bool isFinished(error) {
    if (error < this.minError) {
      return true;
    }
    return false;
  }
}

class WeightChange implements StopCondition {
  double variation;

  WeightChange(this.variation) {}

  bool isFinished(weights) {
    int finished = 0;

    for (Weight weight in weights) {
      if (weight.variation < this.variation) {
        finished++;
      }
    }

    if (finished = weights.length) {
      return true;
    } else {
      return false;
    }

  }


}
